package org.codehaus.mojo.jboss.packaging;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on jboss-packaging-maven-plugin.<br/> Call <pre>  mvn jboss-packaging:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Jan 10 22:39:20 CET 2011
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.6)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:jboss-packaging-maven-plugin:2.2", 0 );
        append( sb, "", 0 );

        append( sb, "JBoss Packaging Maven Plugin", 0 );
        append( sb, "Maven plugin for generating various JBoss deployable archive files.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 11 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "aop".equals( goal ) )
        {
            append( sb, "jboss-packaging:aop", 0 );
            append( sb, "Builds a deployable JBoss AOP Archive.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.outputDirectory}/META-INF/jboss-aop.xml)", 2 );
                append( sb, "The location of the JBoss AOP descriptor file (jboss-aop.xml). If it is present in src/main/resources/META-INF then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "esb".equals( goal ) )
        {
            append( sb, "jboss-packaging:esb", 0 );
            append( sb, "Builds a deployable JBoss ESB Archive.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.outputDirectory}/META-INF/jboss-esb.xml)", 2 );
                append( sb, "The location of the jboss deployment descriptor file (jboss-esb.xml) If it is present in src/main/resources/META-INF then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentXml", 2 );
                append( sb, "Override the deployment xml file", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "esb-exploded".equals( goal ) )
        {
            append( sb, "jboss-packaging:esb-exploded", 0 );
            append( sb, "Deprecated. Use esb goal with \'explodedOnly\' parameter", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "Builds a deployable JBoss ESB exploded Archive.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.outputDirectory}/META-INF/jboss-esb.xml)", 2 );
                append( sb, "The location of the jboss deployment descriptor file (jboss-esb.xml) If it is present in src/main/resources/META-INF then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentXml", 2 );
                append( sb, "Override the deployment xml file", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "har".equals( goal ) )
        {
            append( sb, "jboss-packaging:har", 0 );
            append( sb, "Builds a deployable JBoss Hibernate Archive. Note that in versions of jboss prior to 4.0.3 the deployment descriptor for a HAR was \'hibernate-service.xml\'. In 4.0.3 this changed to use \'jboss-service.xml\' similar to the SAR format. In JBoss 5 and above, the HAR deployment descriptor can be any file with a name that matches the pattern \'*-hibernate.xml\'. If the parameter \'deploymentDescriptorFile\' is not set, this goal will first look for \'jboss-service.xml\', then \'hibernate-service.xml\' and if those are not found, it will search for a file ending with * \'-hibernate.xml\'", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile", 2 );
                append( sb, "The name of the hibernate deployment descriptor file. If left blank, the goal will automatically search for \'jboss-service.xml\', \'hibernate-service.xml\', and \'*-hibernate.xml\' in that order.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "har-exploded".equals( goal ) )
        {
            append( sb, "jboss-packaging:har-exploded", 0 );
            append( sb, "Deprecated. Use har goal with \'explodedOnly\' parameter", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "Builds a deployable JBoss Hibernate exploded Archive.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile", 2 );
                append( sb, "The name of the hibernate deployment descriptor file. If left blank, the goal will automatically search for \'jboss-service.xml\', \'hibernate-service.xml\', and \'*-hibernate.xml\' in that order.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "jboss-packaging:help", 0 );
            append( sb, "Display help information on jboss-packaging-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0jboss-packaging:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "par".equals( goal ) )
        {
            append( sb, "jboss-packaging:par", 0 );
            append( sb, "Builds a deployable JBoss Process Archive.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.directory}/${project.build.finalName}/processdefinition.xml)", 2 );
                append( sb, "The location of the jbpm deployment descriptor file (processdefinition.xml) If it is present in src/main/resources then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The character encoding of the resource files.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "filters (Default: ${project.build.filters})", 2 );
                append( sb, "The filters used when copying the resource files. By default this will use the resource filters specified in the POM.", 3 );
                append( sb, "", 0 );

                append( sb, "jbpmDirectory (Default: src/main/jbpm)", 2 );
                append( sb, "The directory where JBoss JBPM resources are located.", 3 );
                append( sb, "", 0 );

                append( sb, "jpdlDirectory (Default: src/main/jpdl/${project.artifactId})", 2 );
                append( sb, "The directory where JBoss JPDL resources are located.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingClassesDirectory (Default: ${project.build.directory}/${project.build.finalName}/classes)", 2 );
                append( sb, "The directory where compiled classes and resources are placed.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );

                append( sb, "resources", 2 );
                append( sb, "The resources to include in the packaged archive. Specifying this overrides using jbpmDirectory and jpdlDirectory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "sar".equals( goal ) )
        {
            append( sb, "jboss-packaging:sar", 0 );
            append( sb, "Builds a deployable JBoss Service Archive.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.outputDirectory}/META-INF/jboss-service.xml)", 2 );
                append( sb, "The location of the jboss deployment descriptor file (jboss-service.xml) If it is present in src/main/resources/META-INF then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "sar-exploded".equals( goal ) )
        {
            append( sb, "jboss-packaging:sar-exploded", 0 );
            append( sb, "Deprecated. Use sar goal with \'explodedOnly\' parameter", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "Builds a deployable JBoss Service exploded Archive.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.outputDirectory}/META-INF/jboss-service.xml)", 2 );
                append( sb, "The location of the jboss deployment descriptor file (jboss-service.xml) If it is present in src/main/resources/META-INF then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "sar-inplace".equals( goal ) )
        {
            append( sb, "jboss-packaging:sar-inplace", 0 );
            append( sb, "Deprecated. Use sar goal with \'explodedOnly\' parameter", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "Builds a deployable JBoss Service in place exploded Archive.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.outputDirectory}/META-INF/jboss-service.xml)", 2 );
                append( sb, "The location of the jboss deployment descriptor file (jboss-service.xml) If it is present in src/main/resources/META-INF then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "spring".equals( goal ) )
        {
            append( sb, "jboss-packaging:spring", 0 );
            append( sb, "Builds a deployable JBoss Spring Archive.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The maven archive configuration to use.", 3 );
                append( sb, "", 0 );

                append( sb, "archiveName (Default: ${project.build.finalName})", 2 );
                append( sb, "The name of the generated packaging archive.", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the generated artifact. If given, the artifact will not be the primary project artifact.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDest (Default: ${project.build.directory}/${project.build.finalName}/META-INF)", 2 );
                append( sb, "The destination of the deployment descriptor file.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorDestName", 2 );
                append( sb, "The filename for the output deployment descriptor. By default the deployment descriptor will retain the same filename.", 3 );
                append( sb, "", 0 );

                append( sb, "deploymentDescriptorFile (Default: ${project.build.outputDirectory}/META-INF/jboss-spring.xml)", 2 );
                append( sb, "The location of the jboss deployment descriptor file (jboss-spring.xml). If it is present in src/main/resources/META-INF with that name then it will automatically be included. Otherwise this parameter must be set.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeAll (Default: false)", 2 );
                append( sb, "All artifacts are excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Dependency Artifacts excluded from packaging within the generated archive file. Use artifactId:groupId in nested exclude tags.", 3 );
                append( sb, "", 0 );

                append( sb, "explodedOnly (Default: false)", 2 );
                append( sb, "Whether to generate only the exploded archive format. By default both an exploded directory and a zipped file will be created. If set to \'true\' only the exploded directory will be created.", 3 );
                append( sb, "", 0 );

                append( sb, "libDirectory (Default: ${project.build.directory}/${project.build.finalName}/lib)", 2 );
                append( sb, "The directory where to put the libs.", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "The manifest file for the archive.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "The directory for the generated packaging.", 3 );
                append( sb, "", 0 );

                append( sb, "packagingDirectory (Default: ${project.build.directory}/${project.build.finalName})", 2 );
                append( sb, "The directory where the JBoss packaging is built.", 3 );
                append( sb, "", 0 );

                append( sb, "primaryArtifact (Default: true)", 2 );
                append( sb, "Whether this is the main artifact of the current project.", 3 );
                append( sb, "", 0 );

                append( sb, "removeDependencyVersions (Default: false)", 2 );
                append( sb, "Whether to remove the version numbers from the filenames of the included dependencies. By default the included dependencies will have the format [artifactId]-[version]-[classifier].[type] If this parameter is set to true, the jar name will be in the format [artifactId]-[classifier].[type]", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
